<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE xsl:stylesheet [

<!ENTITY space '<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform"> </xsl:text>'>
<!ENTITY cr '<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform">&#x0a;</xsl:text>'>
<!ENTITY tab '<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform">&#x09;</xsl:text>'>

<!ENTITY % CommonDTD SYSTEM "common.dtd">
%CommonDTD;

]>

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:lxslt="http://xml.apache.org/xslt"
    xmlns:exslt="http://exslt.org/common"
    xmlns:x="http://xml.usagiyojimbo.com/x/"
    xmlns:date="http://exslt.org/dates-and-times"
        extension-element-prefixes="exslt date"
>
<xsl:output method="text"/>

<xsl:template name="debug-dump">
    <xsl:param name="data"/>

    <xsl:message>
        <xsl:for-each select="$data">
            <xsl:apply-templates select="." mode="debug"/>
        </xsl:for-each>
    </xsl:message>
</xsl:template>
        
<xsl:template match="text()" mode="debug">
    <!-- <xsl:text>(text)</xsl:text> -->
    <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="comment()" mode="debug">
    <xsl:text>(comment)</xsl:text>
    <xsl:text>&lt;!--</xsl:text>
    <xsl:value-of select="."/>
    <xsl:text>--&gt;</xsl:text>
</xsl:template>

<xsl:template match="*" mode="debug">
    <!-- <xsl:text>(node)</xsl:text> -->
    <xsl:text>&lt;</xsl:text>
    <xsl:value-of select="name()"/>
    <xsl:apply-templates select="@*" mode="debug"/>
    <xsl:text>&gt;</xsl:text>

    <xsl:apply-templates select="node()" mode="debug"/>

    <xsl:text>&lt;/</xsl:text>
    <xsl:value-of select="name(.)"/>
    <xsl:text>&gt;</xsl:text>
</xsl:template>

<xsl:template match="@*" mode="debug">
    &space;
    <xsl:value-of select="name()"/>
    <xsl:text>="</xsl:text>
    <xsl:value-of select="."/>
    <xsl:text>"</xsl:text>
</xsl:template>

<xsl:template name="debug-path">
    <xsl:param name="node"/>

    <xsl:message><xsl:text>debug-path: </xsl:text>
	<xsl:for-each select="ancestor-or-self::*">
	    <xsl:variable name="pos" select="count(preceding-sibling::*)+1"/>

	    <xsl:text>/</xsl:text>
	    <xsl:value-of select="name()"/>
	    <xsl:text>[</xsl:text>
	    <xsl:choose>
		<xsl:when test="@id and @id != ''">
		    <xsl:text>@id = '</xsl:text>
		    <xsl:value-of select="@id"/>
		    <xsl:text>'</xsl:text>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:value-of select="$pos"/>
		</xsl:otherwise>
	    </xsl:choose>
	    <xsl:text>]</xsl:text>
	</xsl:for-each>
    </xsl:message>
</xsl:template>

</xsl:stylesheet>
