<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE stylesheet [

<!ENTITY space '<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform"> </xsl:text>'>
<!ENTITY cr '<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform">&#x0a;</xsl:text>'>
<!ENTITY tab '<xsl:text xmlns:xsl="http://www.w3.org/1999/XSL/Transform">&#x09;</xsl:text>'>
<!ENTITY new-image '<img border="0" src="{concat($top,&quot;images/new2.gif&quot;)}"/>'>

<!ENTITY % CommonDTD SYSTEM "common.dtd">
%CommonDTD;

]>

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:lxslt="http://xml.apache.org/xslt"
    xmlns:exsl="http://exslt.org/common"
    xmlns:date="http://exslt.org/dates-and-times"
    xmlns:func="http://exslt.org/functions"
        extension-element-prefixes="exsl date func"
        exclude-result-prefixes="exsl date func svg my"
    xmlns:my="my://own.uri"
    xmlns:svg="http://www.w3.org/2000/svg"
    xmlns:x="http://xml.usagiyojimbo.com/x/"
>
<!-- <xsl:import href="date.xsl" />
-->
<xsl:import href="common.xsl" />
<xsl:import href="debug.xsl" />
<xsl:import href="image-common.xsl" />
<xsl:import href="functions/date.date.template.xsl" />
<xsl:import href="functions/date.format-date.template.xsl" />
<xsl:output
    method="html" indent="yes" encoding="iso-8859-1"
/>
    <!-- doctype-public="-//W3C//DTD HTML 3.2 Final//EN" -->

<xsl:param name="top" select="string('')"/>
<xsl:param name="today">
    <xsl:call-template name="date:format-date">
	<xsl:with-param name="date-time">
	    <xsl:call-template name="date:date"/>
	</xsl:with-param>
        <xsl:with-param name="pattern">yyyy-MM-dd</xsl:with-param>
    </xsl:call-template>
</xsl:param>
<xsl:param name="today-cmp">
    <xsl:call-template name="date:format-date">
	<xsl:with-param name="date-time">
	    <xsl:call-template name="date:date"/>
	</xsl:with-param>
        <xsl:with-param name="pattern">yyyyMMdd</xsl:with-param>
    </xsl:call-template>
</xsl:param>
<xsl:param name="link-new-age">
    <xsl:if test="function-available ('date:seconds')">
        <xsl:value-of select="date:seconds('P30D')"/>
    </xsl:if>
</xsl:param>
<xsl:variable name="data" select="document('tmp/data.xml')"/>

<xsl:key name="charKey" match="characters/character" use="@id"/>
<xsl:key name="imgInfoKey" match="image" use="@path"/>

<!-- Just copy every node which has no specific rule to it -->
<xsl:template match="* | @* | text() | comment() | processing-instruction()">
    <xsl:copy>
        <xsl:apply-templates
            select="* | @* | text() | comment() | processing-instruction()"
        />
    </xsl:copy>
</xsl:template>

<xsl:template match="page">
    <html>
	<head>
            <xsl:call-template name="page-meta-info"/>
            
            <xsl:if test="not(head)">
                <xsl:message terminate="yes">page: No head element found.</xsl:message>
            </xsl:if>
	    <xsl:apply-templates select="head/*"/>
	</head>

	<xsl:apply-templates select="body | frameset | noframes | include"/>
    </html>
</xsl:template>

<xsl:template name="page-meta-info">
    <xsl:variable name="keywords">
        usagi yojimbo, usagi yojimbo dojo, samurai, ninja, tomoe ame, usagi, tomoe, japan, japanese, stan sakai, sakai, stan, comic books, comics, furry, furries, rabbits, anthropomorphics, albedo, critters, dark horse, dark horse comics, sword, katana, daisho, yojimbo, akira kurosawa, todd shogun, steve gallacci, bushido
    </xsl:variable>
    
    <meta name="description" content="usagi yojimbo, usagi yojimbo dojo, stan sakai, usagiyojimbo"/>
    <meta name="keywords" content="{$keywords}"/>
    <hidden keywords="{$keywords}"/>
    <meta name="distribution" content="global,local"/>
</xsl:template>

<xsl:template match="links">
    <xsl:apply-templates select="item" mode="links"/>
</xsl:template>

<xsl:template match="item" mode="links">
    <h3>
	<a>
	    <xsl:attribute name="href"><xsl:value-of select="@url"/></xsl:attribute>
	    <xsl:value-of select="@title"/>
	</a>
    </h3>&cr;
    <p><font size="-1"><xsl:apply-templates/></font></p>&cr;

</xsl:template>

<xsl:template match="a">
    <xsl:call-template name="link"/>
</xsl:template>

<xsl:template match="A">
    <xsl:message terminate="yes">Error: Found 'A' element</xsl:message>
</xsl:template>

<xsl:template name="a">
    <a>
        <xsl:for-each select="@*">
	    <xsl:choose>
		<xsl:when test="name() = 'HREF' or name() = 'href'">
		    <xsl:attribute name="href">
			<xsl:call-template name="fix-path">
			    <xsl:with-param name="path" select="."/>
			</xsl:call-template>
		    </xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:copy>
			<xsl:apply-templates select="@*"/>
		    </xsl:copy>
		</xsl:otherwise>
	    </xsl:choose>
	</xsl:for-each>

	<xsl:apply-templates/>
    </a>
</xsl:template>

<xsl:template match="form">
    <xsl:call-template name="form"/>
</xsl:template>

<xsl:template match="FORM">
    <xsl:call-template name="form"/>
</xsl:template>

<xsl:template name="form">
    <form>
        <xsl:for-each select="@*">
	    <xsl:choose>
		<xsl:when test="name() = 'ACTION' or name() = 'action'">
		    <xsl:attribute name="action">
			<xsl:call-template name="fix-path">
			    <xsl:with-param name="path" select="."/>
			</xsl:call-template>
		    </xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:copy>
			<xsl:apply-templates select="@*"/>
		    </xsl:copy>
		</xsl:otherwise>
	    </xsl:choose>
	</xsl:for-each>

	<xsl:apply-templates/>
    </form>
</xsl:template>

<xsl:template match="img">
    <xsl:call-template name="image"/>
</xsl:template>

<xsl:template match="IMG">
    <xsl:call-template name="image"/>
    <xsl:message>IMG found (<xsl:value-of select="@url"/>)</xsl:message>
</xsl:template>

<func:function name="my:lookup-char">
    <xsl:param name="key"/>
    
    <xsl:variable name="real-key">
        <xsl:if test="not (starts-with ($key, 'char-'))">
            <xsl:text>char-</xsl:text>
        </xsl:if>
        <xsl:value-of select="$key"/>
    </xsl:variable>

    <xsl:variable name="result">
	<xsl:for-each select="$data">
	    <xsl:copy-of select="key('charKey', $real-key)"/>
	</xsl:for-each>
    </xsl:variable>

    <xsl:if test="count (exsl:node-set ($result)/character) = 0">
        <xsl:message terminate="yes">my:lookup-char: Couldn't find character "<xsl:value-of select="$real-key"/>"</xsl:message>
    </xsl:if>
    
    <func:result select="exsl:node-set ($result)/character"/>
</func:function>

<xsl:template match="body">
    <body>
	<xsl:choose>
	    <xsl:when test="//body-attr/@background">
		<xsl:attribute name="background">
		    <xsl:call-template name="fix-path">
			<xsl:with-param name="path" select="//body-attr/@background"/>
		    </xsl:call-template>
		</xsl:attribute>
	    </xsl:when>
	    <xsl:when test="@background">
		<xsl:attribute name="background">
		    <xsl:call-template name="fix-path">
			<xsl:with-param name="path" select="@background"/>
		    </xsl:call-template>
		</xsl:attribute>
	    </xsl:when>
	</xsl:choose>

	<xsl:for-each select="@* | //body-attr/@*">
	    <xsl:if test="name() != 'background'
		and name() != 'dojowarp'
		and name() != 'dojofooter'
		and name() != 'sound'
	    ">
		<xsl:copy-of select="."/>
	    </xsl:if>
	</xsl:for-each>

	<xsl:if test="not (//dojowarp) and @dojowarp != 'no'">
	    <xsl:call-template name="dojowarp"/>
	</xsl:if>

	<xsl:apply-templates/>
	
	<xsl:if test="not (//dojofooter) and @dojofooter != 'no'">
	    <xsl:call-template name="dojofooter"/>
	</xsl:if>

	<!-- this is processed at the end so Konquerer doesn't put the midi
	     player somewhere in the middle of the page :-(
	-->
	<xsl:variable name="sound-url">
	    <xsl:choose>
		<xsl:when test="//body-attr/@sound">
		    <xsl:call-template name="fix-path">
			<xsl:with-param name="path" select="//body-attr/@sound"/>
		    </xsl:call-template>
		</xsl:when>
		<xsl:when test="@sound">
		    <xsl:call-template name="fix-path">
			<xsl:with-param name="path" select="@sound"/>
		    </xsl:call-template>
		</xsl:when>
	    </xsl:choose>
	</xsl:variable>
	<xsl:if test="$sound-url != ''">
	    <NOFRAME>&cr;
		<EMBED HEIGHT="2" WIDTH="2" loop="true" AUTOSTART="TRUE" SRC="{$sound-url}"/>&cr;
	    </NOFRAME>&cr;
	    <BGSOUND LOOP="infinite" SRC="{$sound-url}"/>&cr;

	    <p><img src="{$top}images/empty.gif" width="1" height="160"/></p>
	</xsl:if>
    </body>

</xsl:template>

<xsl:variable name="dojowarp-preprocessed">
    <xsl:call-template name="dojowarp"/>
</xsl:variable>

<xsl:template match="dojowarp">
    <xsl:copy-of select="$dojowarp-preprocessed"/>
</xsl:template>

<xsl:template match="dojofooter">
    <xsl:call-template name="dojofooter"/>
</xsl:template>

<xsl:template match="space">
    <xsl:variable name="width">
	<xsl:choose>
	    <xsl:when test="@width">
		<xsl:value-of select="@width"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:text>1</xsl:text>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="height">
	<xsl:choose>
	    <xsl:when test="@height">
		<xsl:value-of select="@height"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:text>1</xsl:text>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <img src="{concat($top,'images/empty.gif')}" 
	width="{$width}" height="{$height}"
    />
</xsl:template>

<xsl:variable name="dojowarpabs-preprocessed">
    <xsl:apply-templates select="document('tmp/dojowarpabs.xml')/dojowarp/node()"/>
</xsl:variable>

<xsl:variable name="dojowarp0-preprocessed">
    <xsl:apply-templates select="document('tmp/dojowarp0.xml')/dojowarp/node()"/>
</xsl:variable>

<xsl:variable name="dojowarp1-preprocessed">
    <xsl:apply-templates select="document('tmp/dojowarp1.xml')/dojowarp/node()"/>
</xsl:variable>

<xsl:template name="dojowarp">
    <xsl:choose>
	<xsl:when test="$top = '/'">
	    <xsl:copy-of select="$dojowarpabs-preprocessed"/>
	</xsl:when>
	<xsl:when test="$top = ''">
	    <xsl:copy-of select="$dojowarp0-preprocessed"/>
	</xsl:when>
	<xsl:when test="$top = '../'">
	    <xsl:copy-of select="$dojowarp1-preprocessed"/>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:message terminate="yes">dojowarp: Illegal value '<xsl:value-of select="$top"/>' for $top</xsl:message>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:variable name="footerabs-preprocessed">
    <xsl:apply-templates select="document('tmp/footerabs.xml')/footer/node()"/>
</xsl:variable>

<xsl:variable name="footer0-preprocessed">
    <xsl:apply-templates select="document('tmp/footer0.xml')/footer/node()"/>
</xsl:variable>

<xsl:variable name="footer1-preprocessed">
    <xsl:apply-templates select="document('tmp/footer1.xml')/footer/node()"/>
</xsl:variable>

<xsl:template match="lmod">
    <xsl:param name="lmod">
	<xsl:choose>
	    <xsl:when test="ancestor::page/@lmod">
		<xsl:value-of select="ancestor::page/@lmod"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:call-template name="date:date"/>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:param>

    <p><xsl:text>Last change: </xsl:text>
    <xsl:call-template name="date:format-date">
	<xsl:with-param name="date-time" select="$lmod"/>
	<xsl:with-param name="pattern">dd.&nbsp;MMM&nbsp;yyyy</xsl:with-param>
    </xsl:call-template>
    </p>
</xsl:template>

<xsl:template name="dojofooter">
    <xsl:param name="lmod">
	<xsl:choose>
	    <xsl:when test="/page/@lmod">
		<xsl:value-of select="/page/@lmod"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:call-template name="date:date"/>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:param>

    <hr/>

    <p><xsl:text>Last change: </xsl:text>
    <xsl:call-template name="date:format-date">
	<xsl:with-param name="date-time" select="$lmod"/>
	<xsl:with-param name="pattern">dd.&nbsp;MMM&nbsp;yyyy</xsl:with-param>
    </xsl:call-template>
    </p>

    <!-- <xsl:apply-templates select="document('footer.xml')/footer"/> -->
    <xsl:choose>
	<xsl:when test="$top = '/'">
	    <xsl:copy-of select="$footerabs-preprocessed"/>
	</xsl:when>
	<xsl:when test="$top = ''">
	    <xsl:copy-of select="$footer0-preprocessed"/>
	</xsl:when>
	<xsl:when test="$top = '../'">
	    <xsl:copy-of select="$footer1-preprocessed"/>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:message terminate="yes">dojofooter: Illegal value '<xsl:value-of select="$top"/>' for $top</xsl:message>
	</xsl:otherwise>
    </xsl:choose>

    <xsl:call-template name="insert-copyright"/>
</xsl:template>

<xsl:template match="synref">
    <xsl:variable name="key" select="@key"/>

    <xsl:choose>
	<!--
	<xsl:when test="@type = 'toc'">
            <xsl:call-template name="insert-toc">
                <xsl:with-param name="key" select="$key"/>
            </xsl:call-template>
	</xsl:when>
	-->
	<xsl:when test="@type = 'synopses'">
            <xsl:call-template name="insert-synopses">
                <xsl:with-param name="key" select="$key"/>
            </xsl:call-template>
	</xsl:when>

	<xsl:otherwise>
	    <xsl:message>synref: key=<xsl:value-of select="$key"/> Unknown type '<xsl:value-of select="@type"/>'</xsl:message>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="toc">
    <xsl:variable name="key">
	<xsl:choose>
	    <xsl:when test="@key != '*'">
		<xsl:text>comic-</xsl:text>
		<xsl:value-of select="@key"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:text>*</xsl:text>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <xsl:call-template name="insert-toc">
	<xsl:with-param name="key" select="$key"/>
    </xsl:call-template>
</xsl:template>

<xsl:template name="insert-toc">
    <xsl:param name="key"/>
    
    <xsl:choose>
        <xsl:when test="$key = '*'">
            <!-- <xsl:message>TOC of all</xsl:message> -->
            <xsl:for-each select="$data/data/stories/synopsis">
                <xsl:sort select="head/sort-title"/>
                <xsl:sort select="head/subtitle"/>

		<xsl:text>Synopsis for </xsl:text>
		<xsl:call-template name="story-link">
		    <xsl:with-param name="ref" select="@id"/>
		</xsl:call-template>
                <br/>&cr;
            </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
            <!-- <xsl:message>TOC of <xsl:value-of select="$key"/></xsl:message> -->
            <xsl:if test="not($data/data/stories/synopsis[head/contained/@ref = $key])">
		<xsl:message>insert-toc: Warning: No synopses found for <xsl:value-of select="$key"/></xsl:message>
	    </xsl:if>

            <xsl:for-each select="$data/data/stories/synopsis[head/contained/@ref = $key]">
                <xsl:sort select="head/contained[@ref = $key]/@index" data-type="number"/>
		<!-- <xsl:message>TOC of <xsl:value-of select="head/title"/></xsl:message> -->
		<xsl:text>Synopsis for </xsl:text>
		<xsl:call-template name="story-link">
		    <xsl:with-param name="ref" select="@id"/>
		</xsl:call-template>
                <br/>&cr;
            </xsl:for-each>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="insert-synopses">
    <xsl:param name="key"/>
    
    <xsl:choose>
        <xsl:when test="$key = '*'">
            <xsl:for-each select="$data/data/stories/synopsis">
                <xsl:sort select="head/sort-title"/>
                <xsl:sort select="head/subtitle"/>

                <xsl:call-template name="convert-synopsis">
                    <xsl:with-param name="node" select="."/>
                    <xsl:with-param name="pos" select="position()"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
            <xsl:if test="not($data/data/stories/synopsis[head/contained/@ref = $key])">
		<xsl:message>insert-synopses: Warning: No synopses found for <xsl:value-of select="$key"/></xsl:message>
	    </xsl:if>

            <xsl:for-each select="$data/data/stories/synopsis[head/contained/@ref = $key]">
                <xsl:sort select="head/contained[@ref = $key]/@index" data-type="number"/>

                <!-- <xsl:message><xsl:value-of select="head/contained[@ref = $key]/@index"/></xsl:message> -->
                <xsl:call-template name="convert-synopsis">
                    <xsl:with-param name="node" select="."/>
                    <xsl:with-param name="pos" select="position()"/>
                </xsl:call-template>
            </xsl:for-each>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="cover-img">
    <xsl:variable name="ref" select="concat('comic-',@ref)"/>

    <xsl:choose>
	<xsl:when test="contains(@ref,'#')">
	    <xsl:variable name="real-ref" select="substring-before($ref,'#')"/>
	    <xsl:variable name="name" select="substring-after($ref,'#')"/>
    <!-- <xsl:message>cover-link: real-ref='<xsl:value-of select="$real-ref"/>'</xsl:message> -->

	    <xsl:call-template name="cover-img">
		<xsl:with-param name="ref" select="$real-ref"/>
		<xsl:with-param name="name" select="$name"/>
	    </xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:call-template name="cover-img">
		<xsl:with-param name="ref" select="$ref"/>
	    </xsl:call-template>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="cover-img">
    <xsl:param name="ref"/>
    <xsl:param name="name"/>

    <xsl:variable name="ref-node" select="$data/data/comics/comic[@id = $ref]"/>
    <xsl:if test="not($ref-node)">
        <xsl:message>cover-img: No comic found: <xsl:value-of select="$ref"/></xsl:message>
    </xsl:if>

    <!-- GRMBL.. this doesn't work because it puts a tree fragment into
       cover-dummy instead of the a node set :-( 
    <xsl:variable name="cover-dummy"><xsl:choose
	    ><xsl:when test="$name != ''"
		><xsl:value-of select="$ref-node/cover[@name = $name]"
	    /></xsl:when
	    ><xsl:otherwise
		><xsl:value-of select="$ref-node/cover[1]"
	    /></xsl:otherwise
	></xsl:choose
    ></xsl:variable>
    <xsl:variable name="cover" select="exsl:node-set($cover-dummy)"/>
    <xsl:if test="not($cover)">
	<xsl:message>cover-img: Warning: No cover with the name '<xsl:value-of select="$name"/>' in the comic '<xsl:value-of select="$ref"/>' found.</xsl:message>
    </xsl:if>
    <xsl:message>name=<xsl:value-of select="$name"/></xsl:message>
    <xsl:message>cover=<xsl:value-of select="$ref-node/cover[@name = $name]/@url"/></xsl:message>
    <xsl:message>cover=<xsl:value-of select="$ref-node/cover[1]/@url"/></xsl:message>
    <xsl:message>cover=<xsl:value-of select="$cover"/></xsl:message>
    <xsl:message>cover=<xsl:value-of select="name($cover)"/></xsl:message>
    <xsl:message>cover/url=<xsl:value-of select="$cover/@url"/></xsl:message>
    -->
    <xsl:variable name="path">
	<xsl:choose>
	    <xsl:when test="$name != ''">
		<xsl:call-template name="fix-path">
		    <xsl:with-param name="path" select="$ref-node/cover[@name = $name]/@url"/>
		</xsl:call-template>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:call-template name="fix-path">
		    <xsl:with-param name="path" select="$ref-node/cover[1]/@url"/>
		</xsl:call-template>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="icon">
	<xsl:choose>
	    <xsl:when test="$name != ''">
		<xsl:value-of select="$ref-node/cover[@name = $name]/@icon"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:value-of select="$ref-node/cover[1]/@icon"/>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="icon-width">
	<xsl:choose>
	    <xsl:when test="$name != ''">
		<xsl:value-of select="$ref-node/cover[@name = $name]/@icon-width"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:value-of select="$ref-node/cover[1]/@icon-width"/>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="icon-height">
	<xsl:choose>
	    <xsl:when test="$name != ''">
		<xsl:value-of select="$ref-node/cover[@name = $name]/@icon-height"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:value-of select="$ref-node/cover[1]/@icon-height"/>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <a>
	<xsl:attribute name="href">
	    <xsl:value-of select="$path"/>
	</xsl:attribute>

	<xsl:call-template name="insert-img">
	    <xsl:with-param name="border">0</xsl:with-param>
	    <xsl:with-param name="src" select="$icon"/>
	    <xsl:with-param name="align" select="@align"/>
	    <xsl:with-param name="width" select="$icon-width"/>
	    <xsl:with-param name="height" select="$icon-height"/>
	</xsl:call-template>
    </a>
</xsl:template>

<xsl:template match="cover-link">
    <xsl:variable name="ref" select="concat('comic-',@ref)"/>

    <xsl:choose>
	<xsl:when test="contains(@ref,'#')">
	    <xsl:variable name="real-ref" select="substring-before($ref,'#')"/>
	    <xsl:variable name="name" select="substring-after($ref,'#')"/>
    <!-- <xsl:message>cover-link: real-ref='<xsl:value-of select="$real-ref"/>'</xsl:message> -->

	    <xsl:call-template name="cover-link">
		<xsl:with-param name="ref-node" select="$data/data/comics/comic[@id = $real-ref]"/>
		<xsl:with-param name="name" select="$name"/>
	    </xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:call-template name="cover-link">
		<xsl:with-param name="ref-node" select="$data/data/comics/comic[@id = $ref]"/>
	    </xsl:call-template>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="cover-link">
    <xsl:param name="name"/>
    <xsl:param name="ref-node"/>

    <xsl:if test="not($ref-node)">
	<xsl:message>cover-link: Error: Called without a ref-node</xsl:message>
    </xsl:if>
    <!--
    <xsl:message>cover-link: name='<xsl:value-of select="$name"/>'</xsl:message>
    <xsl:message>cover-link: ref-node='<xsl:value-of select="$ref-node/title"/>'</xsl:message>
    -->

    <xsl:variable name="path">
	<xsl:choose>
	    <xsl:when test="$name != ''">
		<xsl:if test="not($ref-node/cover[@name = $name]/@url)">
		    <xsl:message>cover-link: Error: Kann key='<xsl:value-of select="$ref-node/@id"/>', name='<xsl:value-of select="$name"/>' nicht finden.</xsl:message>
		</xsl:if>

		<xsl:call-template name="fix-path">
		    <xsl:with-param name="path" select="$ref-node/cover[@name = $name]/@url"/>
		</xsl:call-template>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:call-template name="fix-path">
		    <xsl:with-param name="path" select="$ref-node/cover/@url"/>
		</xsl:call-template>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <a>
	<xsl:attribute name="href">
	    <xsl:value-of select="$path"/>
	</xsl:attribute>

	<xsl:apply-templates/>
    </a>
</xsl:template>
    
<xsl:template name="convert-synopsis">
    <xsl:param name="node"/>
    <xsl:param name="pos"/>
    <!-- <xsl:message>convert-synopsis: head=<xsl:value-of select="$node/head"/></xsl:message> -->
    
    <xsl:if test="$pos > 1">
	<hr size="6"/>
    </xsl:if>

    <a>
	<xsl:attribute name="NAME">
	    <xsl:value-of select="$pos"/>
	</xsl:attribute>
    </a>&cr;
    <h2>
	<xsl:value-of select="$node/head/title"/>
    </h2>
    <xsl:if test="$node/head/subtitle != ''">
	<h3>
	    <em><xsl:value-of select="$node/head/subtitle"/></em>
	</h3>
    </xsl:if>

    <table border="0">
    <tr>
	<td valign="top"><strong>First&nbsp;Published:</strong></td>
	<td valign="top"><xsl:value-of select="$node/head/published"/></td>
    </tr>

    <tr>
	<td valign="top"><strong>Contained In:</strong></td>
	<td valign="top">
	    <table border="0" cellspacing="0">
		<xsl:for-each select="$node/head/contained">
		    <xsl:variable name="ref" select="@ref"/>
		    
		    <xsl:if test="$data/data/comics/comic[@id = $ref]">
		    <tr>
			<td valign="top">
			    <img width="11" height="11">
				<xsl:attribute name="src">
				    <xsl:value-of select="concat($top,'images/middot.gif')"/>
				</xsl:attribute>
			    </img>
			</td>
			<xsl:call-template name="convert-contained">
                            <xsl:with-param name="ref" select="$ref"/>
                        </xsl:call-template>
		    </tr>
		    </xsl:if>
		</xsl:for-each>
	    </table>
	</td>
    </tr>
    
    <xsl:if test="$node/head/next/@ref and $node/head/next/@ref != ''">
	<tr>
	    <td valign="top"><strong>Next Part:</strong></td>
	    <td valign="top">
		<xsl:call-template name="story-link">
		    <xsl:with-param name="ref" select="concat('story-',$node/head/next/@ref)"/>
		</xsl:call-template>
	    </td>
	</tr>
    </xsl:if>
    
    <xsl:if test="$node/head/note">
	<tr>
	    <td valign="top"><strong>Story Notes:</strong></td>
	    <td valign="top">
                <a name="story-notes"/>
                <xsl:apply-templates select="$node/head/note"/>
	    </td>
	</tr>
    </xsl:if>

    </table>
    <br/>

    <xsl:apply-templates select="$node/body/p"/>
</xsl:template>

<xsl:template name="convert-contained">
    <xsl:param name="ref"/>
    <xsl:variable name="ref-node" select="$data/data/comics/comic[@id = $ref]"/>

    <td valign="top" width="400">
	<p>
            <xsl:call-template name="comic-link">
                <xsl:with-param name="ref" select="$ref"/>
            </xsl:call-template>
	    <xsl:if test="@pages">
		<br/>
                <xsl:text>(Pages </xsl:text>
                <xsl:value-of select="@pages"/>
                <xsl:text>)</xsl:text>
	    </xsl:if>
	</p>

	<xsl:for-each select="note">
	    <p><xsl:apply-templates/></p>
	</xsl:for-each>

	<xsl:for-each select="$ref-node/note">
	    <p><xsl:apply-templates/></p>
	</xsl:for-each>
    </td>
    <td valign="top">
	<xsl:if test="$ref-node/cover">
            <xsl:call-template name="cover-img">
                <xsl:with-param name="name" select="@name"/>
                <xsl:with-param name="ref" select="$ref-node/@id"/>
            </xsl:call-template>
	</xsl:if>
    </td>
</xsl:template>

<xsl:template match="include">
    <xsl:call-template name="include">
        <xsl:with-param name="file" select="@file"/>
        <xsl:with-param name="key" select="@key"/>
    </xsl:call-template>
</xsl:template>

<xsl:template name="include">
    <xsl:param name="file"/>
    <xsl:param name="key"/>

    <xsl:if test="$file = ''">
        <xsl:message>include: Keine Datei angegeben</xsl:message>
    </xsl:if>
    <xsl:if test="not(document($file)/node())">
        <xsl:message>include: Kann Datei <xsl:value-of select="$file"/> nicht ffnen</xsl:message>
    </xsl:if>
    <xsl:if test="not(document($file)/parts)">
        <xsl:message>include: Die Datei <xsl:value-of select="$file"/> ist keine Include-Datei</xsl:message>
    </xsl:if>
    <xsl:if test="count(document($file)/parts/part[@key = $key]) = 0">
        <xsl:message>include: Kann Key <xsl:value-of select="$key"/> in Datei <xsl:value-of select="$file"/> nicht finden</xsl:message>
    </xsl:if>

    <xsl:apply-templates select="document($file)/parts/part[@key = $key]/node()"/>
</xsl:template>

<xsl:template match="news">
    <xsl:variable name="max" select="@max"/>

    <table border="0" cellspacing="0" cellpadding="0">
	<xsl:apply-templates select="item[position() &lt; $max]" mode="news"/>
    </table>
</xsl:template>

<xsl:variable name="news-item-color">#4498dc</xsl:variable>

<xsl:template match="item" mode="news">
    <tr>
	<td valign="top" align="right"><div style="background-color: {$news-item-color};
            text-align: right; padding: 5; margin-right: 0;
            margin-left: 5;"><strong>
		<xsl:call-template name="date:format-date">
		    <xsl:with-param name="date-time" select="@lmod"/>
		    <xsl:with-param name="pattern">dd.&nbsp;MMM&nbsp;yyyy</xsl:with-param>
	        </xsl:call-template>
	    </strong></div></td>
	<td valign="top" align="left" bgcolor="{$news-item-color}" width="8">&nbsp;</td>
	<td valign="top" align="left"><div valign="top"
            style="padding-left: 5; margin-left: 0;">
	    <xsl:apply-templates/>
	</div></td>
    </tr>
    <tr>
        <td>&nbsp;</td>
        <td valign="top"><div style="padding: 0; margin-right: 0; margin-left: 0;
            border-top-width: 8; border-top-color: {$news-item-color};
            border-top-style: solid;">&nbsp;</div></td>
        <td valign="top"><div style="padding: 0; margin-right: 0; margin-left: 0;
            border-top-width: 8; border-top-color: {$news-item-color};
            border-top-style: solid;">&nbsp;</div></td>
    </tr>
</xsl:template>

<xsl:template match="events">
    <xsl:variable name="max" select="@max"/>

    <div align="center">
    <table border="0" cellspacing="3" cellpadding="3" bgcolor="{$news-item-color}" width="80%">
    <tr>
	<th bgcolor="#4040E0" width="160"><font color="white">Date</font></th>
	<th bgcolor="#4040E0"><font color="white"><xsl:value-of select="@title"/></font></th>
    </tr>
	<xsl:for-each select="event">
	    <xsl:sort select="@date" data-type="text" order="descending"/>
	    
	    <xsl:if test="position() &lt;= $max">
		<xsl:apply-templates select="."/>
	    </xsl:if>
	</xsl:for-each>
    </table>
    </div>
</xsl:template>

<xsl:template match="event">
    <xsl:variable name="date">
	<xsl:call-template name="date:format-date">
	    <xsl:with-param name="date-time" select="@date"/>
	    <xsl:with-param name="pattern">yyyyMMdd</xsl:with-param>
	</xsl:call-template>
    </xsl:variable>
    <!-- <xsl:message>today=<xsl:value-of select="$today-cmp"/> date=<xsl:value-of select="$date"/></xsl:message> -->

    <tr>
	<td valign="top" align="right" bgcolor="#F0F0FF"><font>
	    <xsl:choose>
		<xsl:when test="$today-cmp &lt; $date">
		    <xsl:attribute name="color">blue</xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:attribute name="color">black</xsl:attribute>
		</xsl:otherwise>
	    </xsl:choose>
	    <strong>
		<xsl:call-template name="date:format-date">
		    <xsl:with-param name="date-time" select="@date"/>
		    <xsl:with-param name="pattern">dd.&nbsp;MMMM&nbsp;yyyy</xsl:with-param>
	        </xsl:call-template>
	    </strong>
	</font></td>
	<td valign="top" bgcolor="white">
	    <xsl:apply-templates/>
	</td>
    </tr>
</xsl:template>

<xsl:template match="rem">
    <!-- ignore contents -->
</xsl:template>

<xsl:template match="b">
    <strong><xsl:apply-templates/></strong>
</xsl:template>

<xsl:template match="B">
    <strong><xsl:apply-templates/></strong>
</xsl:template>

<xsl:template match="dojoboard">
    <a href="{concat($top,'forum/index.php')}">
        <xsl:for-each select="@*">
            <xsl:copy-of select="."/>
        </xsl:for-each>
        <xsl:choose>
            <xsl:when test="node()">
                <xsl:apply-templates select="node()"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>DojoBoard</xsl:text>
            </xsl:otherwise>
        </xsl:choose>
    </a>
</xsl:template>

<xsl:template match="faqs">
    <xsl:for-each select="faq-item">
	<xsl:if test="position() > 1">
	    <hr/>
	</xsl:if>
        <a>
            <xsl:attribute name="name">
                <xsl:text>faq</xsl:text>
                <xsl:value-of select="position()"/>
            </xsl:attribute>
        </a>
	<p><i><strong>
            <xsl:value-of select="position()"/>
            <xsl:text>.&nbsp;</xsl:text>
            <xsl:apply-templates select="faq-q/* | faq-q/text()"/>
        </strong></i></p>
        <xsl:choose>
            <xsl:when test="name(*[1]) = 'p'">
                <xsl:apply-templates select="faq-a/* | faq-a/text()"/>
            </xsl:when>
            <xsl:otherwise>
                <p>
                    <xsl:apply-templates select="faq-a/* | faq-a/text()"/>
                </p>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:for-each>
</xsl:template>

<xsl:template match="faq-toc">
    <ol>
        <xsl:for-each select="//faqs/faq-item">
            <!-- <xsl:value-of select="position()"/>
            <xsl:text>.&nbsp;</xsl:text> -->
            <li>
                <a>
                    <xsl:attribute name="href">
                        <xsl:text>#faq</xsl:text>
                        <xsl:value-of select="position()"/>
                    </xsl:attribute>
                    <xsl:apply-templates select="faq-q/* | faq-q/text()"/>
                </a>
            </li>
        </xsl:for-each>
    </ol>
</xsl:template>

<xsl:template match="appearances">
    <table border="1">
	<tr>
	    <th>Issue</th>
	    <th>Story</th>
	    <th>Characters</th>
	</tr>
	<xsl:apply-templates/>
    </table>
</xsl:template>

<xsl:template match="appearance">
    <xsl:variable name="key" select="concat('comic-',@key)"/>
    <xsl:variable name="comic" select="$data/data/comics/comic[@id = $key]"/>
    <xsl:variable name="stories" select="$data/data/stories/synopsis[head/contained/@ref = $key]"/>
    <xsl:variable name="current" select="."/>
    <xsl:if test="not($comic)">
	<xsl:message>appearance: Comic '<xsl:value-of select="$key"/>' not found</xsl:message>
    </xsl:if>
    
    <!-- <xsl:message>798: stories=<xsl:value-of select="count($stories)"/></xsl:message> -->

    <xsl:for-each select="$stories">
        <tr>
            <xsl:if test="position() = 1">
                <td valign="top" rowspan="{count($stories)}">
                    <strong>
                        <xsl:call-template name="comic-link">
                            <xsl:with-param name="ref" select="$comic/@id"/>
                        </xsl:call-template>
                    </strong>
		    <br/>
                    
                    <xsl:if test="$comic/published">
                        <xsl:text>(</xsl:text>
                        <xsl:value-of select="$comic/published"/>
                        <xsl:text>)</xsl:text>
                        <br/>
                    </xsl:if>
                    
                    <xsl:apply-templates select="$current/* | $current/text()"/>
                </td>
            </xsl:if>

	    <!-- <xsl:message><xsl:value-of select="head/title"/></xsl:message> -->
	    <td valign="top">
                <xsl:call-template name="story-link">
                    <xsl:with-param name="ref" select="@id"/>
                </xsl:call-template>
	    </td>
	    <td valign="top">
                <xsl:call-template name="insert-char-list">
                    <xsl:with-param name="list" select="head/chars/@refs"/>
                    <xsl:with-param name="story-ref" select="@id"/>
                </xsl:call-template>
	    </td>
        </tr>
    </xsl:for-each>
</xsl:template>

<xsl:key name="charKey" match="character" use="@id"/>

<xsl:template name="insert-char-list">
    <xsl:param name="list"/>
    <xsl:param name="story-ref"/>
    <!-- <xsl:message>insert-char-list: list=<xsl:value-of select="$list"/></xsl:message>
    <xsl:message>insert-char-list: list=<xsl:value-of select="count(id($list))"/></xsl:message> -->
    <!-- <xsl:message>insert-char-list: list=<xsl:value-of select="count(id($story-ref))"/></xsl:message> -->

    <!-- <xsl:message>insert-char-list: list=<xsl:value-of select="$list"/></xsl:message> -->
    <xsl:for-each select="id($list)">
	<xsl:sort select="name"/>
	<xsl:sort select="prename"/>
        <!-- <xsl:message>id=<xsl:value-of select="@id"/></xsl:message> -->
        <!-- <xsl:message>name=<xsl:value-of select="prename"/></xsl:message> -->
	<xsl:variable name="char-ref" select="@id"/>

	<xsl:choose>
	    <xsl:when test="first-story/@ref = $story-ref">
		<strong>
		    <xsl:call-template name="char-link">
			<xsl:with-param name="ref" select="$char-ref"/>
		    </xsl:call-template>
		</strong>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:call-template name="char-link">
		    <xsl:with-param name="ref" select="$char-ref"/>
		</xsl:call-template>
	    </xsl:otherwise>
	</xsl:choose>
	<br/>
    </xsl:for-each>
</xsl:template>

<xsl:template match="character-list">
    <table border="0" width="100%">
    <xsl:for-each select="item">
        <xsl:if test="position() > 1">
            <tr><td colspan="3"><br/><hr/><br/></td></tr>&cr;
        </xsl:if>
        
	<xsl:apply-templates select="." mode="character"/>
    </xsl:for-each>
    </table>
</xsl:template>

<xsl:template match="item" mode="character">
    <xsl:variable name="ref" select="concat('char-',@ref)"/>
    <xsl:variable name="char" select="my:lookup-char ($ref)"/>
    <!-- <xsl:message><xsl:value-of select="$ref"/></xsl:message> -->
    <xsl:choose>
        <xsl:when test="$char">
            <xsl:for-each select="$char">
                <xsl:call-template name="insert-char-item"/>
		<tr><td colspan="3">
		    <xsl:call-template name="char-link">
			<xsl:with-param name="ref" select="$ref"/>
			<xsl:with-param name="text">See the character sheet for more information</xsl:with-param>
		    </xsl:call-template>
		</td></tr>
            </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
            <tr><td>
	    <xsl:text>Unknown character </xsl:text>
            <xsl:value-of select="$ref"/>
            <xsl:message>item[character]: Unknown character <xsl:value-of select="$ref"/></xsl:message>
            </td></tr>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="insert-char-item">
    <!-- <xsl:message><xsl:value-of select="name"/></xsl:message> -->
    
    <tr>
        <td valign="top" align="left"><strong>Name:</strong></td>
        <td valign="top" align="left" width="100%">
	    <xsl:if test="title != ''">
		<xsl:value-of select="title"/>
		<xsl:text>&nbsp;</xsl:text>
	    </xsl:if>
	    <xsl:value-of select="name"/>
	    <xsl:if test="name != '' and prename != ''">
		<xsl:text>&nbsp;</xsl:text>
	    </xsl:if>
	    <xsl:value-of select="prename"/></td>
        <td valign="top" align="right" rowspan="12">
            <xsl:if test="img">
                <xsl:for-each select="img[position() = 1]">
                    <xsl:call-template name="image">
			<xsl:with-param name="mode">large</xsl:with-param>
			<xsl:with-param name="align">right</xsl:with-param>
		    </xsl:call-template>
                </xsl:for-each>
            </xsl:if>
        </td>
    </tr>
    <xsl:if test="name/@pron != '' or prename/@pron != '' ">
	<tr>
	    <td align="left">&nbsp;</td>
	    <td align="left">
		<xsl:text>(</xsl:text>
		<xsl:value-of select="name/@pron"/>
		<xsl:if test="name/@pron != '' and prename/@pron != ''">
		    <xsl:text>&nbsp;</xsl:text>
		</xsl:if>
		<xsl:value-of select="prename/@pron"/>
		<xsl:text>)</xsl:text>
	    </td>
	</tr>
    </xsl:if>
    <xsl:if test="name/@kana != '' or prename/@kana != '' ">
	<tr>
	    <td align="left">&nbsp;</td>
	    <td align="left">
		<xsl:text>(</xsl:text>
		<xsl:value-of select="name/@kana"/>
		<xsl:if test="name/@kana != '' and prename/@kana != ''">
		    <xsl:text>&nbsp;</xsl:text>
		</xsl:if>
		<xsl:value-of select="prename/@kana"/>
		<xsl:text>)</xsl:text>
	    </td>
	</tr>
    </xsl:if>
    <tr>
	<td valign="top" align="left"><strong>First&nbsp;Story&nbsp;Appearance:</strong></td>
	<td valign="top" align="left">
	    <xsl:call-template name="story-link">
		<xsl:with-param name="ref" select="concat('story-',first-story/@ref)"/>
	    </xsl:call-template>
	</td>
    </tr>
    <tr>
	<td valign="top" align="left"><strong>First&nbsp;Issue&nbsp;Appearance:</strong></td>
	<td valign="top" align="left">
	    <xsl:call-template name="comic-link">
		<xsl:with-param name="ref" select="concat('comic-',first-issue/@ref)"/>
	    </xsl:call-template>
	</td>
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Caste:</strong></td>
        <td valign="top" align="left"><xsl:value-of select="caste"/> 
            <xsl:if test="caste = ''"><xsl:text>Unknown</xsl:text></xsl:if>
        </td> 
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Profession:</strong></td>
        <td valign="top" align="left"><xsl:value-of select="profession"/>
            <xsl:if test="profession = ''"><xsl:text>Unknown</xsl:text></xsl:if>
        </td> 
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Known&nbsp;Fighting&nbsp;Proficiencies:</strong></td>
        <td valign="top" align="left">
            <xsl:value-of select="fight-prof"/>
            <xsl:if test="fight-prof = ''"><xsl:text>None</xsl:text></xsl:if>
        </td> 
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Weapon&nbsp;of&nbsp;Preference:</strong></td>
        <td valign="top" align="left"><xsl:value-of select="weapon"/>
            <xsl:if test="weapon = ''"><xsl:text>Unknown</xsl:text></xsl:if>
        </td> 
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Anthropomorphic&nbsp;Identity:</strong></td>
        <td valign="top" align="left"><xsl:value-of select="anthro"/></td> 
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Clan&nbsp;Allegiance:</strong></td>
        <td valign="top" align="left"><xsl:value-of select="clan"/> 
            <xsl:if test="not(clan) or clan = ''"><xsl:text>Unknown</xsl:text></xsl:if>
        </td> 
    </tr>
    <tr>
        <td valign="top" align="left"><strong>Famous Quote:</strong></td>
        <td valign="top" align="left"><xsl:value-of select="quote"/> 
            <xsl:if test="quote = ''"><xsl:text>None</xsl:text></xsl:if>
        </td> 
    </tr>
</xsl:template>

<xsl:template match="story-toc">
    <xsl:for-each select="$data/data/stories/synopsis[@id != '' and head/title != '']">
	<xsl:sort select="head/sort-title"/>
	<xsl:sort select="head/subtitle"/>

	<xsl:call-template name="story-link">
	    <xsl:with-param name="ref" select="@id"/>
	</xsl:call-template><br/>
    </xsl:for-each>
</xsl:template>

<xsl:template match="story-link">
    <xsl:choose>
	<xsl:when test="text() != '' or child">
	    <xsl:call-template name="story-link">
		<xsl:with-param name="ref" select="concat('story-',@ref)"/>
		<xsl:with-param name="text" select="text() | *"/>
	    </xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:call-template name="story-link">
		<xsl:with-param name="ref" select="concat('story-',@ref)"/>
	    </xsl:call-template>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="story-link">
    <xsl:param name="ref"/>
    <xsl:param name="text"/>
    
    <xsl:variable name="use-ref">
        <xsl:choose>
            <xsl:when test="contains($ref,'#')">
                <xsl:value-of select="substring-before($ref,'#')"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$ref"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    <xsl:variable name="name" select="substring-after($ref,'#')"/>

    <xsl:variable name="story"
        select="$data/data/stories/synopsis[@id = $use-ref]"
    />
    <xsl:variable name="real-text">
	<xsl:choose>
	    <xsl:when test="$text">
		<xsl:copy-of select="$text"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:value-of select="$story/head/title"/>
		<xsl:if test="$story/head/subtitle != ''">
		    <xsl:text>: </xsl:text>
		    <em><xsl:value-of select="$story/head/subtitle"/></em>
		</xsl:if>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <xsl:choose>
        <xsl:when test="$story">
            <a>
                <xsl:attribute name="href">
                    <xsl:value-of select="concat($top,'stories/',substring($use-ref,7),'.html')"/>
                    <xsl:if test="$name != ''">
                        <xsl:text>#</xsl:text>
                        <xsl:value-of select="$name"/>
                    </xsl:if>
                </xsl:attribute>
		<xsl:copy-of select="$real-text"/>
            </a>
        </xsl:when>
        <xsl:otherwise>
	    <xsl:text>Unknown story </xsl:text>
            <xsl:value-of select="$ref"/>
            <xsl:message>story-link: Unknown story <xsl:value-of select="$ref"/></xsl:message>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="comic-toc">
    <xsl:for-each select="$data/data/comics/comic[@id != '' and title != '']">
	<xsl:sort select="title"/>
	<xsl:sort select="subtitle"/>

	<xsl:call-template name="comic-link">
	    <xsl:with-param name="ref" select="@id"/>
	</xsl:call-template><br/>
    </xsl:for-each>
</xsl:template>

<xsl:template match="comic-link">
    <xsl:choose>
	<xsl:when test="text() != '' or child">
	    <xsl:call-template name="comic-link">
		<xsl:with-param name="ref" select="concat('comic-',@ref)"/>
		<xsl:with-param name="text" select="text() | *"/>
	    </xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:call-template name="comic-link">
		<xsl:with-param name="ref" select="concat('comic-',@ref)"/>
	    </xsl:call-template>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="comic-link">
    <xsl:param name="ref"/>
    <xsl:param name="comic"
        select="$data/data/comics/comic[@id = $ref]"
    />
    <!--
    <xsl:param name="comic-group"
        select="$data/data/comics/comic-group[@id = $ref]"
    />
    -->
    <xsl:param name="text">
	<xsl:value-of select="$comic/title"/>
	<xsl:if test="$comic/subtitle != ''">
	    <xsl:text>: </xsl:text>
	    <em><xsl:value-of select="$comic/subtitle"/></em>
	</xsl:if>
    </xsl:param>
    <xsl:param name="name" select="@name"/>
    <xsl:variable name="use-name">
        <xsl:text>.html</xsl:text>
        <xsl:if test="$name != ''">
            <xsl:text>#</xsl:text>
            <xsl:value-of select="$name"/>
        </xsl:if>
    </xsl:variable>
    
    <!--
    <xsl:message>title=<xsl:value-of select="$comic/title"/></xsl:message>
    <xsl:message>subtitle=<xsl:value-of select="$comic/subtitle"/></xsl:message>
    <xsl:message>ref=<xsl:value-of select="$ref"/></xsl:message>
    <xsl:message>comic=<xsl:value-of select="$comic"/></xsl:message>
    <xsl:message>cg=<xsl:value-of select="$comic-group"/></xsl:message>
    <xsl:message>text=<xsl:copy-of select="$text"/></xsl:message>
    <xsl:message>text=<xsl:value-of select="$text"/></xsl:message>
    -->

    <xsl:choose>
        <xsl:when test="$comic">
            <a>
                <xsl:attribute name="href">
                    <xsl:value-of select="concat($top,'comics/',substring($ref,7),$use-name)"/>
                </xsl:attribute>
		<xsl:copy-of select="$text"/>
            </a>
        </xsl:when>
        <xsl:otherwise>
	    <xsl:text>Unknown comic </xsl:text>
            <xsl:value-of select="$ref"/>
            <xsl:message>comic-link: Unknown comic <xsl:value-of select="$ref"/></xsl:message>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="char-toc">
    <xsl:for-each select="$data/data/characters/character[@id != '']">
	<xsl:sort select="concat(name,prename,title)" data-type="text"/>

	<xsl:call-template name="char-link">
	    <xsl:with-param name="ref" select="@id"/>
	</xsl:call-template><br/>
    </xsl:for-each>
</xsl:template>

<xsl:template match="char-link">
    <xsl:choose>
	<xsl:when test="node()">
	    <xsl:call-template name="char-link">
		<xsl:with-param name="ref" select="concat('char-',@ref)"/>
		<xsl:with-param name="text" select="node()"/>
	    </xsl:call-template>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:call-template name="char-link">
		<xsl:with-param name="ref" select="concat('char-',@ref)"/>
	    </xsl:call-template>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="char-link">
    <xsl:param name="ref"/>
    <xsl:param name="char" select="my:lookup-char ($ref)"/>
    <xsl:param name="text">
	<xsl:if test="not($char)">
	    <xsl:text>FIXME Unknown character </xsl:text>
            <xsl:value-of select="$ref"/>
	</xsl:if>
        <xsl:if test="$char and $char/name = '' and $char/prename = ''">
	    <xsl:text>FIXME </xsl:text>
            <xsl:value-of select="$ref"/>
	</xsl:if>
	<xsl:if test="$char/title != ''">
	    <xsl:value-of select="$char/title"/>
	    <xsl:text> </xsl:text>
	</xsl:if>
	<xsl:value-of select="$char/name"/>
	<xsl:if test="$char/name != '' and $char/prename != ''">
	    <xsl:text> </xsl:text>
	</xsl:if>
	<xsl:value-of select="$char/prename"/>
    </xsl:param>
    <xsl:param name="omit-links">no</xsl:param>
    <xsl:param name="style"/>
    <xsl:param name="class"/>

    <xsl:if test="$ref = 'char-' or $ref = ''">
	<xsl:call-template name="debug-path"><xsl:with-param name="data" select="."/></xsl:call-template>
	<xsl:call-template name="debug-dump"><xsl:with-param name="data" select=".."/></xsl:call-template>
	<xsl:message terminate="yes">char-link: No ref given</xsl:message>
    </xsl:if>

    
    <xsl:choose>
        <xsl:when test="$char and $char/name = '' and $char/prename = ''">
	    <xsl:value-of select="$text"/>
	    <xsl:message>char-link: Warning: Character '<xsl:value-of select="$ref"/>' is not complete.</xsl:message>
	</xsl:when>
        <xsl:when test="$omit-links = 'yes'">
            <xsl:copy-of select="$text"/>
        </xsl:when>
        <xsl:when test="$char">
            <a>
                <xsl:attribute name="href">
                    <xsl:value-of select="concat($top,'characters/',substring($ref,6),'.html')"/>
                </xsl:attribute>
		<xsl:if test="$style != ''">
		    <xsl:attribute name="style">
			<xsl:value-of select="$style"/>
		    </xsl:attribute>
		</xsl:if>
		<xsl:if test="$class != ''">
		    <xsl:attribute name="class">
			<xsl:value-of select="$class"/>
		    </xsl:attribute>
		</xsl:if>
                
		<xsl:copy-of select="$text"/>
            </a>
        </xsl:when>
        <xsl:otherwise>
            <xsl:value-of select="$text"/>
            <xsl:message>char-link: Unknown character <xsl:value-of select="$ref"/></xsl:message>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="editor">
    <xsl:choose>
        <xsl:when test="ancestor::p">
            <b><xsl:text>[</xsl:text>
                <xsl:apply-templates/>
            <xsl:text>]</xsl:text></b>
        </xsl:when>
        <xsl:when test="p">
            <xsl:for-each select="*">
                <xsl:choose>
                    <xsl:when test="name() = 'p'">
                        <p><b>
                            <xsl:text>[</xsl:text>
                            <xsl:apply-templates/>
                            <xsl:if test="position() = last()"> 
                                <xsl:text>]</xsl:text>
                            </xsl:if>
                        </b></p>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:apply-templates select="."/>
                    </xsl:otherwise>
                </xsl:choose>

            </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
            <p><b>[<xsl:apply-templates/>]</b></p>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="box">
    <xsl:variable name="align">
	<xsl:choose>
	    <xsl:when test="@align"><xsl:value-of select="@align"/></xsl:when>
	    <xsl:otherwise>center</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="width">
	<xsl:choose>
	    <xsl:when test="@width"><xsl:value-of select="@width"/></xsl:when>
	    <xsl:otherwise>100%</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="bgcolor">
	<xsl:choose>
	    <xsl:when test="@bgcolor"><xsl:value-of select="@bgcolor"/></xsl:when>
	    <xsl:otherwise>white</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="frame-color">
	<xsl:choose>
	    <xsl:when test="@frame-color"><xsl:value-of select="@frame-color"/></xsl:when>
	    <xsl:otherwise>black</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="frame-width">
	<xsl:choose>
	    <xsl:when test="@frame-width"><xsl:value-of select="@frame-width"/></xsl:when>
	    <xsl:otherwise>2</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <xsl:variable name="padding">
	<xsl:choose>
	    <xsl:when test="@padding"><xsl:value-of select="@padding"/></xsl:when>
	    <xsl:otherwise>5</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>

    <xsl:call-template name="box">
	<xsl:with-param name="align" select="$align"/>
	<xsl:with-param name="width" select="$width"/>
	<xsl:with-param name="bgcolor" select="$bgcolor"/>
	<xsl:with-param name="frame-color" select="$frame-color"/>
	<xsl:with-param name="frame-width" select="$frame-width"/>
	<xsl:with-param name="padding" select="$padding"/>
    </xsl:call-template>
</xsl:template>

<xsl:template name="box">
    <xsl:param name="align">center</xsl:param>
    <xsl:param name="width">100%</xsl:param>
    <xsl:param name="bgcolor">white</xsl:param>
    <xsl:param name="frame-color">black</xsl:param>
    <xsl:param name="frame-width">2</xsl:param>
    <xsl:param name="padding">5</xsl:param>

    <table border="0" bgcolor="{$frame-color}" width="{$width}" cellpadding="0" cellspacing="{$frame-width}" align="{$align}"><tr><td>
        <table border="0" bgcolor="{$bgcolor}" width="100%" cellspacing="0" cellpadding="{$padding}"><tr><td>
            <xsl:apply-templates/>
        </td></tr></table>
    </td></tr></table>
</xsl:template>

<xsl:variable name="fanart" select="document('tmp/fanart.xml')"/>

<xsl:template match="fanart">
    <xsl:variable name="ref" select="substring-before(@ref,'#')"/>
    <xsl:variable name="img-name" select="substring-after(@ref,'#')"/>
	
    <xsl:variable name="artist" select="$fanart/fanart/artist[@id = $ref]"/>
    <xsl:if test="not($artist)">
	<xsl:message>fanart: Error: No artist found for '<xsl:value-of select="@ref"/>' (<xsl:value-of select="$ref"/>#<xsl:value-of select="$img-name"/>)</xsl:message>
    </xsl:if>

    <xsl:variable name="img" select="$artist/img[@name = $img-name]"/>
    <xsl:if test="not($img)">
	<xsl:message terminate="yes">fanart: Error: No img found for '<xsl:value-of select="@ref"/>' (<xsl:value-of select="$ref"/>#<xsl:value-of select="$img-name"/>)</xsl:message>
    </xsl:if>
    <xsl:if test="count($img) > 1">
	<xsl:message terminate="yes">fanart: Error: Several images found for '<xsl:value-of select="@ref"/>' (<xsl:value-of select="$ref"/>#<xsl:value-of select="$img-name"/>)</xsl:message>
    </xsl:if>
    <xsl:variable name="credits">
	<xsl:text>Fan Art by </xsl:text>
	<xsl:if test="$artist/prename != ''">
	    <xsl:value-of select="$artist/prename"/>
	    &space;
	</xsl:if>
	<xsl:value-of select="$artist/name"/>
    </xsl:variable>

    <a name="{concat($ref,'-',$img-name)}"/>
    <font size="-1"><xsl:value-of select="$credits"/></font><br/>

    <xsl:variable name="scale">
	<xsl:choose>
	    <xsl:when test="@scale">
		 <xsl:value-of select="@scale"/>
	    </xsl:when>
	    <xsl:otherwise>1</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <xsl:call-template name="fanart-img">
	<xsl:with-param name="img" select="$img"/>
	<xsl:with-param name="alt" select="$credits"/>
	<xsl:with-param name="scale" select="$scale"/>
    </xsl:call-template>
    <br/>
    <xsl:if test="$img/text() != '' or $img/*">
	<font size="-1"><xsl:apply-templates select="$img/* | $img/text()"/></font><br/>
    </xsl:if>
    <xsl:if test="text() != '' or *">
	<font size="-1"><xsl:apply-templates select="* | text()"/></font><br/>
    </xsl:if>
</xsl:template>

<xsl:template name="fanart-img">
    <xsl:param name="img"/>
    <xsl:param name="alt"/>
    <xsl:param name="src"/>
    <xsl:param name="scale">1</xsl:param>

    <xsl:variable name="use-src">
	<xsl:choose>
	    <xsl:when test="$src = ''">
		<xsl:call-template name="fix-path">
		    <xsl:with-param name="path" select="$img/@url"/>
		</xsl:call-template>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:call-template name="fix-path">
		    <xsl:with-param name="path" select="$src"/>
		</xsl:call-template>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    <!-- - ->
    <xsl:message>fanart-img: <xsl:value-of select="$use-src"/></xsl:message>
    <xsl:message>    width=<xsl:value-of select="$img/@width"/></xsl:message>
    <xsl:message>    scale=<xsl:value-of select="$scale"/></xsl:message>
    <xsl:message>    new-width=<xsl:value-of select="$img/@width * $scale"/></xsl:message>
    <!- - -->

    <xsl:choose>
	<xsl:when test="$src = '' and $img/@icon != ''">
	    <a>
		<xsl:attribute name="href">
		    <xsl:call-template name="fix-path">
			<xsl:with-param name="path" select="$img/@url"/>
		    </xsl:call-template>
		</xsl:attribute>

		<xsl:call-template name="fanart-img">
		    <xsl:with-param name="img" select="$img"/>
		    <xsl:with-param name="alt" select="$alt"/>
		    <xsl:with-param name="src" select="$img/@icon"/>
		    <xsl:with-param name="scale" select="$scale"/>
		</xsl:call-template>
	    </a>
	</xsl:when>
	<xsl:otherwise>
	    <img border="{$img/@border}">
		<xsl:if test="$img/@width != '' and $img/@height != ''">
		    <xsl:variable name="new-width" select="$img/@width * $scale"/>
		    <xsl:variable name="new-height" select="$img/@height * $scale"/>
		    <xsl:if test="$new-width = 'NaN'">
			<xsl:message terminate="yes">new-width=NaN! $img/@width="<xsl:value-of select="$img/@width"/>" scale="<xsl:value-of select="$scale"/>"</xsl:message>
		    </xsl:if>
		    <xsl:if test="$new-height = 'NaN'">
			<xsl:message terminate="yes">new-height=NaN! $img/@height="<xsl:value-of select="$img/@height"/>" scale="<xsl:value-of select="$scale"/>"</xsl:message>
		    </xsl:if>
		    <xsl:attribute name="width"><xsl:value-of select="$new-width"/></xsl:attribute>
		    <xsl:attribute name="height"><xsl:value-of select="$new-height"/></xsl:attribute>
		</xsl:if>
		<xsl:attribute name="src"><xsl:value-of select="$use-src"/></xsl:attribute>
		<xsl:attribute name="alt"><xsl:value-of select="$alt"/></xsl:attribute>
	    </img>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="insert-fanart-toc">
    <!-- <xsl:message>Artist <xsl:value-of select="count($fanart/fanart/artist)"/></xsl:message> -->

    <xsl:variable name="uses" select="$data//fanart"/>
    
    <!-- <xsl:message>Fanart <xsl:value-of select="count($uses)"/></xsl:message> -->

    <xsl:for-each select="$fanart/fanart/artist">
        <xsl:sort select="concat(prename,name)"/>

        <xsl:variable name="id" select="@id"/>
        
        <!-- <xsl:message>Artist <xsl:value-of select="$id"/></xsl:message> -->
        
        &middot;
        <xsl:if test="prename">
            <xsl:value-of select="prename"/>
            <xsl:text>&nbsp;</xsl:text>
        </xsl:if>
        <xsl:value-of select="name"/>
        <br/>&cr;
        
        <xsl:for-each select="img">
            <xsl:variable name="name" select="@name"/>
            <xsl:variable name="key" select="concat($id,'#',$name)"/>
            <xsl:variable name="anchor" select="concat($id,'-',$name)"/>
            
            <xsl:variable name="used" select="$uses[@ref = $key]"/>
            <xsl:choose>
                <xsl:when test="count($used) = 0">
                    <xsl:message>insert-fanart-toc: Warning: Fanart '<xsl:value-of select="$key"/>' is unused.</xsl:message>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:if test="count($used) > 1">
                        <xsl:message>insert-fanart-toc: Warning: Fanart '<xsl:value-of select="$key"/>' is used more than once.</xsl:message>
                    </xsl:if>
                    
                    <xsl:variable name="comic" select="$used[1]/ancestor::comic"/>
                    
                    <img src="{concat($top,'images/empty.gif')}" width="40" height="1"/>
                    <font size="-1">
                        <xsl:text>-</xsl:text>
                        <xsl:call-template name="comic-link">
                            <xsl:with-param name="ref" select="$comic/@id"/>
                            <xsl:with-param name="comic" select="$comic"/>
                            <xsl:with-param name="name" select="$anchor"/>
                        </xsl:call-template>
                    </font>
                    <br/>&cr;
                </xsl:otherwise>
            </xsl:choose>
        </xsl:for-each>
        
        <br/>
    </xsl:for-each>
</xsl:template>

<xsl:template match="note/title">
    <p align="center"><b><xsl:apply-templates/></b></p>
</xsl:template>

<xsl:template match="note/title" mode="title">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="story-note">
    <xsl:call-template name="story-note">
        <xsl:with-param name="ref" select="concat('story-',@ref)"/>
    </xsl:call-template>
</xsl:template>

<xsl:template name="story-note">
    <xsl:param name="ref"/>
    
    <xsl:variable name="story" select="$data/data/stories/synopsis[@id = $ref]"/>
    <xsl:if test="not($story)">
        <xsl:message>story-note: Warning: No synopses found for <xsl:value-of select="$ref"/></xsl:message>
    </xsl:if>
    
    <a>
        <xsl:attribute name="href">
            <xsl:value-of select="concat($top,'stories/',@ref,'.html#story-notes')"/>
        </xsl:attribute>
        
        <xsl:apply-templates select="$story/head/note/title" mode="title"/>
    </a>
    
    <xsl:variable name="contained" select="$story/head/contained"/>
    
    <xsl:if test="$contained">
        <font size="-1">
            <xsl:text> (</xsl:text> 
            <xsl:call-template name="comic-link">
                <xsl:with-param name="ref" select="$contained[1]/@ref"/>
            </xsl:call-template>
            <xsl:text>)</xsl:text>
        </font>
    </xsl:if>
</xsl:template>

<xsl:template match="ignore">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="copyright">
    <!-- do nothing -->
</xsl:template>

<xsl:template match="insert-copyright">
    <xsl:call-template name="insert-copyright"/>
</xsl:template>

<xsl:template name="insert-copyright">
    <hr/>
    
    <p><font size="-2">
    <xsl:text>Usagi Yojimbo, including all prominent characters
    featured in the stories and the distinctive likenesses thereof are
    trademarks of Stan Sakai and Usagi Studios. Usagi Yojimbo is a registered
    trademark of Stan Sakai. Names, characters, places, and incidents featured
    in this publication either are the product of the authors imagination or are
    used fictitiously. Any resemblance to actual persons (living or dead),
    events, institutions, or locales, without satiric content, is
    coincidental.</xsl:text><br/>
    <xsl:for-each select="//copyright/* | //copyright/text()">
        <font size="-2">
            <xsl:apply-templates select="."/>
        </font>
        <br/>
    </xsl:for-each>
    </font></p>
        
</xsl:template>

<xsl:template match="sc">
    <xsl:call-template name="sc">
        <xsl:with-param name="content" select="string(.)"/>
        <xsl:with-param name="big">
            <xsl:choose>
                <xsl:when test="@big != ''">
                    <xsl:value-of select="@big"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:text>+1</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:with-param>
        <xsl:with-param name="small">
            <xsl:choose>
                <xsl:when test="@small != ''">
                    <xsl:value-of select="@small"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:text>-1</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:variable name="upper">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable>
<xsl:variable name="lower">abcdefghijklmnopqrstuvwxyz</xsl:variable>

<xsl:template name="sc">
    <xsl:param name="content"/>
    <xsl:param name="big"/>
    <xsl:param name="small"/>
    
    <xsl:if test="$content != ''">
        <xsl:variable name="prefix">
            <xsl:call-template name="same-case">
                <xsl:with-param name="text" select="$content"/>
            </xsl:call-template>
        </xsl:variable>
        
        <xsl:choose>
            <xsl:when test="contains('ABCDEFGHIJKLMNOPQRSTUVWXYZ',substring($prefix,1,1))">
                <font size="{$big}">
                    <xsl:value-of select="$prefix"/>
                </font>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="$small != ''">
                        <font size="{$small}">
                            <!-- <xsl:value-of select="translate($prefix,$lower,$upper)"/> -->
                            <xsl:value-of select="translate($prefix,$lower,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
                        </font>
                        
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="translate($prefix,$lower,'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
        
        <xsl:if test="string-length($prefix) > 0">
            <xsl:call-template name="sc">
                <xsl:with-param name="content" select="substring($content,string-length($prefix)+1)"/>
                <xsl:with-param name="big" select="$big"/>
                <xsl:with-param name="small" select="$small"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:if>
</xsl:template>

<xsl:template name="same-case">
    <xsl:param name="text"/>

    <xsl:choose>
        <xsl:when test="contains('ABCDEFGHIJKLMNOPQRSTUVWXYZ',substring($text,1,1))">
            <xsl:call-template name="same-case-upper">
                <xsl:with-param name="text" select="$text"/>
            </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:call-template name="same-case-lower">
                <xsl:with-param name="text" select="$text"/>
            </xsl:call-template>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="same-case-upper">
    <xsl:param name="text"/>

    <xsl:if test="$text != ''">
        <xsl:value-of select="substring($text,1,1)"/>
        
        <xsl:if test="contains('ABCDEFGHIJKLMNOPQRSTUVWXYZ',substring($text,2,1))">
            <xsl:call-template name="same-case-upper">
                <xsl:with-param name="text" select="substring($text,2)"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:if>
</xsl:template>

<xsl:template name="same-case-lower">
    <xsl:param name="text"/>

    <xsl:if test="$text != ''">
        <xsl:value-of select="substring($text,1,1)"/>
        
        <xsl:if test="not(contains('ABCDEFGHIJKLMNOPQRSTUVWXYZ',substring($text,2,1)))">
            <xsl:call-template name="same-case-lower">
                <xsl:with-param name="text" select="substring($text,2)"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:if>
</xsl:template>

<xsl:template match="link">
    <xsl:call-template name="link"/>
</xsl:template>

<xsl:template name="link">
    <xsl:variable name="anchor">
        <xsl:if test="contains (@href, '#')">
            <xsl:text>#</xsl:text>
            <xsl:value-of select="substring-after (@href, '#')"/>
        </xsl:if>
    </xsl:variable>
    <xsl:variable name="path">
        <xsl:call-template name="fix-path">
	    <xsl:with-param name="path">
		<xsl:choose>
		    <xsl:when test="contains(@href, '#')">
			<xsl:value-of select="substring-before (@href,'#')"/>
		    </xsl:when>
		    <xsl:otherwise>
			<xsl:value-of select="@href"/>
		    </xsl:otherwise>
		</xsl:choose>
	    </xsl:with-param>
        </xsl:call-template>
    </xsl:variable>

    <xsl:choose>
        <xsl:when test="substring($path,string-length($path)-4) = '.page'">
            <!-- - -> 
            <xsl:message>    link: Reading '<xsl:value-of select="$path"/>'</xsl:message>
            <!- - -->
            <xsl:variable name="doc" select="document($path)"/>
            <xsl:choose>
                <xsl:when test="$doc and $doc/page">
                    <xsl:variable name="title">
                        <xsl:choose>
                            <xsl:when test="./node()">
				<!-- - -> 
                                <xsl:message>Text in link <xsl:value-of select="$path"/></xsl:message>
                                -->
                                <xsl:copy-of select="node()"/>
                            </xsl:when>
                            <xsl:when test="$doc/page/head/title/node()">
				<!-- - -> 
                                <xsl:message>Text in page header <xsl:value-of select="$path"/></xsl:message>
                                -->
                                <xsl:value-of select="$doc/page/head/title"/>
                            </xsl:when>
                            <xsl:when test="$doc//x:define[@name = 'title']/node()">
				<!-- - -> 
                                <xsl:message>Text in page define <xsl:value-of select="$path"/></xsl:message>
                                -->
                                <xsl:copy-of select="$doc//x:define[@name = 'title']/node()"/>
                            </xsl:when>
                            <xsl:otherwise>
				<xsl:message terminate="yes">link: Cannot determine title <xsl:value-of select="$path"/></xsl:message>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
		    
                    <xsl:variable name="url">
                        <xsl:choose>
                            <xsl:when test="$doc/page/@target-url != ''">
                                <xsl:call-template name="fix-path">
                                    <xsl:with-param name="path">
                                        <xsl:value-of select="$doc/page/@target-url"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="fix-path">
                                    <xsl:with-param name="path">
                                        <xsl:value-of select="concat($top,substring($path,1,string-length($path)-5),'.html')"/>
                                    </xsl:with-param>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:value-of select="$anchor"/>
                    </xsl:variable>
                    <xsl:variable name="lmod" select="$doc/page/@lmod"/>
                    <!-- <xsl:message>lmod-cmp=<xsl:value-of select="$lmod-cmp"/> last-month-cmp=<xsl:value-of select="$last-month-cmp"/></xsl:message> -->
                    <!-- <xsl:message>diff=<xsl:value-of select="-date:seconds(date:difference($lmod,$today))"/> link-new-age=<xsl:value-of select="$link-new-age"/></xsl:message> -->
                    <xsl:if test="function-available ('date:seconds')">
                        <xsl:if test="$lmod != ''
                            and -date:seconds(date:difference($lmod,$today)) &lt; $link-new-age
                            and @show-new = 'yes'
                        ">
                            &new-image;
                        </xsl:if>
                    </xsl:if>
                    <a href="{$url}">
                        <xsl:for-each select="@*">
                            <xsl:if test="name() != 'href' 
                                    and name() != 'show-lmod'
                                    and name() != 'br-lmod'
                            ">
                                <xsl:apply-templates select="."/>
                            </xsl:if>
                        </xsl:for-each>
                        <xsl:for-each select="exsl:node-set($title)">
                            <xsl:apply-templates select="."/>
                        </xsl:for-each>
                    </a>

                    <xsl:if test="@show-lmod = 'yes' and $lmod != ''">
                        <xsl:choose>
                            <xsl:when test="@br-lmod = 'yes'">
                                <br/>
                            </xsl:when>
                            <xsl:otherwise>
                                &space;
                            </xsl:otherwise>
                        </xsl:choose>
                        <font size="-2">
                            <xsl:text>(</xsl:text>
                            <xsl:call-template name="date:format-date">
                                <xsl:with-param name="date-time" select="$lmod"/>
                                <xsl:with-param name="pattern">dd.&nbsp;MMM&nbsp;yyyy</xsl:with-param>
                            </xsl:call-template>
                            <xsl:text>)</xsl:text>
                        </font>
                    </xsl:if>
                </xsl:when>
                <xsl:otherwise>
                    <a href="{concat($path,$anchor)}">
                        <xsl:for-each select="@*">
                            <xsl:if test="name() != 'href'">
                                <xsl:apply-templates select="."/>
                            </xsl:if>
                        </xsl:for-each>
                        <xsl:apply-templates select="node()"/>
                    </a>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
            <!--
            <xsl:if test="not (starts-with ($path, 'http://'))
                and not (starts-with ($path, 'mailto:'))
                and not (substring($path,string-length($path)-3) = '.mid')
                and not (substring($path,string-length($path)-3) = '.cgi')
                and not (substring($path,string-length($path)-3) = '.php')
                and not (substring($path,string-length($path)) = '/')
            ">
                <xsl:message>    link: Warning: Link points to '<xsl:value-of select="$path"/>'</xsl:message>
            </xsl:if>
            -->
            <a href="{concat($path,$anchor)}">
                <xsl:for-each select="@*">
                    <xsl:if test="name() != 'href'">
                        <xsl:apply-templates select="."/>
                    </xsl:if>
                </xsl:for-each>
                <xsl:apply-templates select="*|text()"/>
            </a>
        </xsl:otherwise>
    </xsl:choose>

</xsl:template>

<xsl:template name="style">
    <xsl:copy-of select="."/>
</xsl:template>

<xsl:template name="sakai-sig">
    <p align="right"><img src="$TOP/uyletters/volume3/graf/sakai_signature2.gif" alt="Stan Sakai"/></p>
</xsl:template>

<xsl:template name="dhc-info">
    <p>Send comments to:<br/>
    <b><font size="+1">USAGI YOJIMBO<br/>
    LETTERS COLUMN</font><br/>
    c/o DARK HORSE COMICS, 10956 SE MAIN STREET, MILWAUKIE, OR 97222<br/>
    E-mail: <a href="mailto:dianas@darkhorse.com"><i>dianas@darkhorse.com</i></a><br/>
    Web: <a href="http://www.darkhorse.com/"><i>www.darkhorse.com</i></a><br/>
    Usagi Yojimbo Dojo: <a href="http://www.usagiyojimbo.com/"><i>www.usagiyojimbo.com</i></a><br/>
    Stan Sakai web site: <a href="http://www.stansakai.com/"><i>www.stansakai.com</i></a><br/>
    Advertising sales: (503) 652-8815 X370<br/>
    Comic Shop Locator Service: (888) 266-4226</b></p>
</xsl:template>

<xsl:template match="dl-img">
    <xsl:variable name="alt">
	<xsl:choose>
	    <xsl:when test="@alt">
		<xsl:value-of select="@alt"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:value-of select="text()"/>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    
    <xsl:call-template name="image">
	<xsl:with-param name="alt" select="$alt"/>
    </xsl:call-template>

    <br/>
    <xsl:apply-templates select="node()"/>
    
    <xsl:variable name="path-key">
        <xsl:call-template name="image-path-key">
            <xsl:with-param name="path" select="@url"/>
        </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="info" select="my:lookup-image-info ($path-key)"/>
    <xsl:if test="$info">
        <br/>
	<xsl:text>Size: </xsl:text>
	<xsl:value-of select="$info/@width"/>
	<xsl:text>x</xsl:text>
	<xsl:value-of select="$info/@height"/>
	&space;
	<xsl:value-of select="$info/@size"/>
    </xsl:if>
</xsl:template>

<xsl:template match="new">
    <xsl:if test="@date != ''
	and -date:seconds(date:difference(@date,$today)) &lt; $link-new-age">
        &new-image;
    </xsl:if>
    <xsl:if test="@date = ''">
        &new-image;
    </xsl:if>
</xsl:template>

<xsl:template match="gallery">
    <xsl:variable name="columns" select="@columns"/>
    <xsl:variable name="column-spacing">40</xsl:variable>
    
    <div align="center">
    <table border="0" cellspacing="0">
    
    <xsl:choose>
	<xsl:when test="$columns = 1">
	    <xsl:for-each select="item">
		<tr>
		    <td align="middle" valign="bottom">
			<xsl:apply-templates select="." mode="gallery-item-image"/>
		    </td>
		</tr>
		<tr>
		    <td align="middle" valign="top">
			<xsl:apply-templates select="node()"/>
		    </td>
		</tr>
		<xsl:if test="position() != last()">
		    <tr>
			<td height="25">&nbsp;</td>
		    </tr>
		</xsl:if>
	    </xsl:for-each>
	</xsl:when>
	<xsl:otherwise>
	    <xsl:for-each select="item[position() mod $columns = 1]">
		<tr>
		    <xsl:for-each select=". | following-sibling::item[position() &lt; $columns]">
			<td align="middle" valign="bottom">
			    <xsl:apply-templates select="." mode="gallery-item-image"/>
			</td>
			<xsl:if test="position() != last()">
			    <td width="{$column-spacing}">&nbsp;</td>
			</xsl:if>
		    </xsl:for-each>
		</tr>
		<tr>
		    <xsl:for-each select=". | following-sibling::item[position() &lt; $columns]">
			<td align="middle" valign="top">
			    <xsl:apply-templates select="node()"/>
			</td>
			<xsl:if test="position() != last()">
			    <td width="{$column-spacing}">&nbsp;</td>
			</xsl:if>
		    </xsl:for-each>
		</tr>
		<xsl:if test="position() != last()">
		    <tr>
			<td height="25">&nbsp;</td>
		    </tr>
		</xsl:if>
	    </xsl:for-each>
	</xsl:otherwise>
    </xsl:choose>
    
    </table>
    </div>
</xsl:template>

<xsl:template match="item" mode="gallery-item-image">
    <xsl:call-template name="image"/>
</xsl:template>

<xsl:template match="interview">
    <xsl:variable name="q">
        <xsl:choose>
            <xsl:when test="@q != ''">
                <xsl:value-of select="@q"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>Question</xsl:text>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    <xsl:variable name="a">
        <xsl:choose>
            <xsl:when test="@a != ''">
                <xsl:value-of select="@a"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>Answer</xsl:text>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    
    <xsl:for-each select="item">
	<p><strong>
            <xsl:choose>
                <xsl:when test="q-item/@name != ''">
                    <xsl:value-of select="q-item/@name"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$q"/>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:text>:&nbsp;</xsl:text>
            <xsl:apply-templates select="q-item/node()"/>
        </strong></p>
        <xsl:choose>
            <xsl:when test="name(a-item/*[1]) = 'p'">
                <p>
                    <i>
                        <xsl:choose>
                            <xsl:when test="a-item/@name != ''">
                                <xsl:value-of select="a-item/@name"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="$a"/>
                            </xsl:otherwise>
                        </xsl:choose>
                    <xsl:text>:</xsl:text>&nbsp;</i>
                    <xsl:apply-templates select="a-item/p[1]/node()"/>
                </p>
                <xsl:apply-templates select="a-item/p[position() > 1]"/>
            </xsl:when>
            <xsl:otherwise>
                <p>
                    <i>
                        <xsl:choose>
                            <xsl:when test="a-item/@name != ''">
                                <xsl:value-of select="a-item/@name"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="$a"/>
                            </xsl:otherwise>
                        </xsl:choose>
                    <xsl:text>:</xsl:text>&nbsp;</i>
                    <xsl:apply-templates select="a-item/node()"/>
                </p>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:for-each>
</xsl:template>

<xsl:template match="link-list">
    <ul>
    <xsl:for-each select="item">
        <li>
            <xsl:call-template name="link"/>
        </li>
    </xsl:for-each>
    </ul>
</xsl:template>

<xsl:template match="chars-of-the-season">
    <xsl:for-each select="item">
        <xsl:apply-templates select="." mode="chars-of-the-season"/>
        <xsl:if test="position() != last()">
            <br/>
        </xsl:if>
    </xsl:for-each>
</xsl:template>

<xsl:template name="get-char-url">
    <xsl:param name="char"/>
    
    <xsl:value-of select="concat($top,'characters/',substring($char/@id,6),'.html')"/>
</xsl:template>

<xsl:template name="get-char-name">
    <xsl:param name="char"/>
    
    <!-- 
    <xsl:message>get-char-name <xsl:value-of select="count($char)"/></xsl:message> 
    <xsl:call-template name="debug-dump"><xsl:with-param name="data" select="$char"/></xsl:call-template>
    -->
    
    <xsl:if test="$char/title != ''">
        <xsl:value-of select="$char/title"/>
        <xsl:text>&nbsp;</xsl:text>
    </xsl:if>
    <xsl:value-of select="$char/name"/>
    <xsl:if test="$char/name != '' and $char/prename != ''">
        <xsl:text>&nbsp;</xsl:text>
    </xsl:if>
    <xsl:value-of select="$char/prename"/>
</xsl:template>

<xsl:template match="item" mode="chars-of-the-season">
    <xsl:variable name="char" select="my:lookup-char (@id)"/>
    <!-- <xsl:call-template name="debug-dump"><xsl:with-param name="data" select="$char"/></xsl:call-template> -->
    <xsl:variable name="char-link">
        <xsl:call-template name="get-char-url">
            <xsl:with-param name="char" select="$char"/>
        </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="name">
        <xsl:call-template name="get-char-name">
            <xsl:with-param name="char" select="$char"/>
        </xsl:call-template>
    </xsl:variable>
    <!-- <xsl:message>item <xsl:value-of select="@id"/> <xsl:value-of select="$name"/></xsl:message> --> 
    
    <xsl:variable name="code">
        <box width="90%" frame-width="4">
            <table border="0">
                <tr>
                    <td>
                        <a href="{$char-link}">
                            <img url="{@img}" border="2"/>
                        </a>
                    </td>
                    <td width="25">&nbsp;</td>
                    <td>
                        <h2 align="center"><sc big="+2" small="+1">Character
                                of the Season <xsl:value-of select="@season"/></sc></h2>
                        <h1 align="center"><xsl:value-of select="$name"/></h1>
                        
                        <p><xsl:apply-templates select="./node()"/></p>
                        
                        <p><a href="{$char-link}">More about <xsl:value-of select="$name"/></a></p>
                    </td>
                </tr>
            </table>
        </box>
    </xsl:variable>

    <xsl:apply-templates select="exsl:node-set ($code)/*"/>
</xsl:template>

<xsl:template match="table">
    <table>
	<xsl:for-each select="@*">
	    <xsl:choose>
		<xsl:when test="name() = 'background'">
		    <xsl:attribute name="background">
			<xsl:call-template name="fix-path">
			    <xsl:with-param name="path" select="."/>
			</xsl:call-template>
		    </xsl:attribute>
		</xsl:when>
		<xsl:otherwise>
		    <xsl:copy/>
		</xsl:otherwise>
	    </xsl:choose>
	</xsl:for-each>

	<xsl:apply-templates select="node()"/>
    </table>
</xsl:template>

<xsl:template match="css-stylesheet">
    <xsl:variable name="href">
	<xsl:choose>
	    <xsl:when test="$top = '/'">
		<xsl:copy-of select="concat('/',@base,'.css')"/>
	    </xsl:when>
	    <xsl:when test="$top = ''">
		<xsl:copy-of select="concat(@base,'.css')"/>
	    </xsl:when>
	    <xsl:when test="$top = '../'">
		<xsl:copy-of select="concat($top,@base,'.css')"/>
	    </xsl:when>
	    <xsl:otherwise>
		<xsl:message terminate="yes">css-stylesheet: Illegal value '<xsl:value-of
    select="$top"/>' for $top</xsl:message>
	    </xsl:otherwise>
	</xsl:choose>
    </xsl:variable>

    <link rel="stylesheet" type="text/css" href="{$href}"/>
</xsl:template>

</xsl:stylesheet>
